//! `SeaORM` Entity, @generated by sea-orm-codegen 1.1.0

use sea_orm::entity::prelude::*;

#[derive(Clone, Debug, PartialEq, DeriveEntityModel, Eq)]
#[sea_orm(table_name = "User")]
pub struct Model {
    #[sea_orm(column_name = "confirmedEmail", column_type = "Text", nullable)]
    pub confirmed_email: Option<String>,
    #[sea_orm(column_type = "Text", nullable)]
    pub email: Option<String>,
    #[sea_orm(column_type = "Text")]
    pub name: String,
    #[sea_orm(column_type = "Text")]
    pub password: String,
    #[sea_orm(column_name = "createdAt")]
    pub created_at: DateTime,
    #[sea_orm(column_name = "isEnabled")]
    pub is_enabled: bool,
    #[sea_orm(column_name = "userGroupId", column_type = "Text")]
    pub user_group_id: String,
    #[sea_orm(primary_key, auto_increment = false, column_type = "Text")]
    pub username: String,
    #[sea_orm(column_name = "setupFinished")]
    pub setup_finished: bool,
    pub permissions: i32,
    #[sea_orm(column_type = "VarBinary(StringLen::None)", nullable)]
    pub avatar: Option<Vec<u8>>,
    #[sea_orm(column_name = "isPublic")]
    pub is_public: bool,
    #[sea_orm(
        column_name = "totpSecret",
        column_type = "VarBinary(StringLen::None)",
        nullable
    )]
    pub totp_secret: Option<Vec<u8>>,
}

#[derive(Copy, Clone, Debug, EnumIter, DeriveRelation)]
pub enum Relation {
    #[sea_orm(has_many = "super::acme_account::Entity")]
    AcmeAccount,
    #[sea_orm(has_many = "super::app_installation::Entity")]
    AppInstallation,
    #[sea_orm(has_many = "super::domain::Entity")]
    Domain,
    #[sea_orm(has_many = "super::passkey::Entity")]
    Passkey,
    #[sea_orm(has_many = "super::proxy::Entity")]
    Proxy,
    #[sea_orm(has_many = "super::service::Entity")]
    Service,
    #[sea_orm(has_many = "super::tcp_proxy::Entity")]
    TcpProxy,
    #[sea_orm(
        belongs_to = "super::user_group::Entity",
        from = "Column::UserGroupId",
        to = "super::user_group::Column::Name",
        on_update = "Cascade",
        on_delete = "Restrict"
    )]
    UserGroup,
}

impl Related<super::acme_account::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::AcmeAccount.def()
    }
}

impl Related<super::app_installation::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::AppInstallation.def()
    }
}

impl Related<super::domain::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Domain.def()
    }
}

impl Related<super::passkey::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Passkey.def()
    }
}

impl Related<super::proxy::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Proxy.def()
    }
}

impl Related<super::service::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::Service.def()
    }
}

impl Related<super::tcp_proxy::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::TcpProxy.def()
    }
}

impl Related<super::user_group::Entity> for Entity {
    fn to() -> RelationDef {
        Relation::UserGroup.def()
    }
}

impl ActiveModelBehavior for ActiveModel {}
